--Talent Spec Display--
local GetActiveSpecGroup = _G.GetActiveSpecGroup
local GetSpecializationInfo = _G.GetSpecializationInfo

local sStats_spec, sStats_specText = sStats:CreateModule("spec")
sStats.RegisterCallback(sStats_spec, "sStats_Modules_Ready", function()

	sStats_spec:RegisterEvent("PLAYER_ENTERING_WORLD");
	sStats_spec:RegisterEvent("PLAYER_TALENT_UPDATE");
	sStats_spec:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED");
	sStats_spec:SetScript("OnEvent", function()
			local masteryIndex = GetActiveSpecGroup();
			local spec
			if (masteryIndex == nil) then
				spec = "Unknown"
			else
				local _, name = GetSpecializationInfo(masteryIndex);
				spec = name
			end
			local specName = string.format("%s", spec)
			sStats:SetModuleText(sStats_specText, specName, " Spec")
		end)
	local tt = GameTooltip
	local tips
	sStats_spec:SetScript("OnEnter", function(self)
			if sStatsPCDB.charSpec then
				tips = sStatsPCDB.sStats_spec.tooltip
			else
				tips = sStatsDB.sStats_spec.tooltip
			end
			if tips then
				tt:SetOwner(self, "ANCHOR_TOPRIGHT")
				local talents = {}
				
				for i = 1, 2 do
					local specValue = GetSpecialization(false,false,i)
					local _, name
					if specValue then
						_, name = GetSpecializationInfo(specValue)
					end
					if name then
						talents[i] = tostring(name)
					else
						talents[i] = "Unknown"
					end
				end
				tt:AddLine("Talent Info")
				tt:AddLine("--------------------------------")
				if talents[1] then
					tt:AddDoubleLine("Primary:", talents[1] ,1,1,1,1,1,1)
				end
				if talents[2] then
					tt:AddDoubleLine("Secondary:", talents[2] ,1,1,1,1,1,1)
				end
				GameTooltip:Show()
			end
		end)
	sStats_spec:SetScript("OnLeave", function() if tips then tt:Hide() end end)
	
	sStatsDB.sStats_spec.tooltip = sStatsDB.sStats_spec.tooltip or true
	if sStatsPCDB.charSpec then
		sStatsPCDB.sStats_spec.tooltip = sStatsPCDB.sStats_spec.tooltip or true
	end
	sStatsOptionsTable.args.sStats_spec.args.tooltip = {
			name = "Show tooltip",
			desc = "Display the tooltip for this module.",
			type = "toggle",
			get = function()
						if sStatsPCDB.charSpec then
							return sStatsPCDB.sStats_spec.tooltip
						else
							return sStatsDB.sStats_spec.tooltip
						end
					end,
			set = function()
						if sStatsPCDB.charSpec then
							sStatsPCDB.sStats_spec.tooltip = not sStatsPCDB.sStats_spec.tooltip
						else
							sStatsDB.sStats_spec.tooltip = not sStatsDB.sStats_spec.tooltip
						end
					end,
		}

end)